// Include needed files
include("shared.lua")


// The default gmod crosshair is crap, draw a new one
function GM:HUDPaint()
	self.BaseClass:HUDPaint() 
	
	// Local player
	local pl = LocalPlayer()
	local ctr_x = ScrW() / 2
	local ctr_y = ScrH() / 2
	
	// New and easy to use fonts
	surface.CreateFont("HL2Cross", 44, 430, true, false, "hl2c_crosshair")
	surface.CreateFont("Arial", 16, 400, true, false, "hl2c_arial")
	surface.CreateFont("Impact", 32, 400, true, false, "hl2c_impact")
	
	// Draw help
	if pl:GetNetworkedInt("show_help") == 1 then
		draw.RoundedBox(8, 24, 24, ScrW() - 48, 27, Color(0, 0, 0, 75))
		draw.DrawText("F1: Toggles help bar. F2: Toggles nav marker. F3: Gives you a vehicle. F4: Removes your vehicle. Type !moveto [playername] to be teleported to that player.", "hl2c_arial", 30, 29, Color(255, 220, 0, 255), 0)
	end
	
	// Draw nav point
	if pl:GetNetworkedInt("show_nav") == 1 then
		local obj_pos = GetGlobalVector("tdml_pos")
		local obj_distance = math.Round(pl:GetPos():Distance(obj_pos) / 39)
		local obj_pos_screen = obj_pos:ToScreen()
		
		// Draw nav marker
		surface.SetTexture(surface.GetTextureID("hl2c_nav_marker"))
		surface.SetDrawColor(255, 255, 255, 255)
		surface.DrawTexturedRect(obj_pos_screen.x - 14, obj_pos_screen.y - 14, 28, 28)
		
		// Draw distance
		draw.DrawText(tostring(obj_distance).." m", "hl2c_arial", obj_pos_screen.x, obj_pos_screen.y + 15, Color(255, 220, 0, 255), 1)
	end
	
	// Draw energy
	local cur_energy = pl:GetNetworkedInt("energy")
	if pl:Alive() and cur_energy < 100 then
		draw.RoundedBox(8, 24, ScrH() - 102, 164, 20, Color(0, 0, 0, 75))
		surface.SetDrawColor(236, 210, 37, 150)
		local draw_energy = cur_energy * 1.53
		surface.DrawRect(30, ScrH() - 98, draw_energy, 12)
	end
	
	// Draw countdown until respawn if dead
	if !pl:Alive() then
		local time_left = math.Round(pl:GetNetworkedInt("next_spawn_time") - CurTime())
		if time_left > 0 then
			draw.DrawText("Respawn In "..tostring(time_left), "hl2c_impact", ctr_x, ctr_y-150, Color(255, 255, 255, 200), 1)
		else
			draw.DrawText("Prepare to Respawn", "hl2c_impact", ctr_x, ctr_y - 150, Color(255, 255, 255, 200), 1)
		end
	end
	
	// If the player is any of the following, do not draw crosshair
	if !pl or !pl:Alive() or pl:InVehicle() then
		if pl:GetNetworkedInt("ch_enabled") == 0 then
			pl:ConCommand("hl2c_crosshair 1")
		end
		return
	else
		if pl:GetNetworkedInt("ch_enabled") == 1 then
			pl:ConCommand("hl2c_crosshair 0")
		end
	end
	
	// Draw the middle crosshair
	surface.SetDrawColor(255, 255, 255, 255)
	surface.DrawRect(ctr_x - 1, ctr_y - 1, 1, 1)
	surface.DrawRect(ctr_x - 11, ctr_y - 1, 1, 1)
	surface.DrawRect(ctr_x + 9, ctr_y - 1, 1, 1)
	surface.DrawRect(ctr_x - 1, ctr_y + 7, 1, 1)
	surface.DrawRect(ctr_x - 1, ctr_y - 9, 1, 1)
	
	// If the player has a weapon, draw our fancy brackets
	if pl:GetActiveWeapon() and pl:GetActiveWeapon():IsValid() then
		draw.SimpleText("(", "hl2c_crosshair", ctr_x - 15, ctr_y, Color(255, 220, 0, 150), 2, 1)
		draw.SimpleText(")", "hl2c_crosshair", ctr_x + 15, ctr_y, Color(255, 220, 0, 150), 0, 1)
	end
end 